package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.MarketType;
import com.izouma.awesomeadmin.service.MarketTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/marketType")
public class MarketTypeController {

    @Autowired
    private MarketTypeService marketTypeService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(MarketType record) {
        List<MarketType> pp = marketTypeService.getMarketTypeList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getMarketType", method = RequestMethod.GET)
    @ResponseBody
    public Result getMarketType(@RequestParam(required = false, value = "id") String id) {
        MarketType data = marketTypeService.getMarketTypeById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(MarketType record) {
        MarketType data = marketTypeService.getMarketType(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, MarketType record) {
        Map<String, Object> result = new HashMap<>();

        List<MarketType> pp =marketTypeService.getMarketTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(MarketType record) {
        boolean num = marketTypeService.createMarketType(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateMarketType(MarketType record) {
        boolean num = marketTypeService.updateMarketType(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteMarketType(MarketType record) {

        boolean num = marketTypeService.deleteMarketType(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, MarketType record) throws Exception {

    List<MarketType> marketTypes = marketTypeService.getMarketTypeList(record);


        String sheetName = "market_type";
        String titleName = "推广类型数据表";
        String fileName = "推广类型表";
        int columnNumber = 10;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "类型" ,   "数额" ,   "备注"  };
        String[][] dataList = new String[marketTypes.size()][10];

        for (int i = 0; i < marketTypes.size(); i++) {

                        dataList[i][0] = String.valueOf(marketTypes.get(i).getId());
                        dataList[i][1] = String.valueOf(marketTypes.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(marketTypes.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(marketTypes.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(marketTypes.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(marketTypes.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(marketTypes.get(i).getTypeName());
                        dataList[i][7] = String.valueOf(marketTypes.get(i).getTypeFlag());
                        dataList[i][8] = String.valueOf(marketTypes.get(i).getMoney());
                        dataList[i][9] = String.valueOf(marketTypes.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

